<template>
	<div class="login-card-container">
		<div class="login-card">
			<div class="login-card-title d-flex justify-center mb-5">
				<span style="font-size: 36px">Welcome to <span class="primary--text">Chatly</span></span>
			</div>
			<v-card>
				<v-form ref="loginForm" @submit.prevent="authenticateUser()">
					<v-container class="d-flex flex-column">
						<div class="form-container">
							<v-text-field v-model="form.data.email" :rules="form.rules.email" clearable label="Email" outlined></v-text-field>
						</div>
						<div class="form-container">
							<v-text-field v-model="form.data.password" :rules="form.rules.password" clearable label="Password" :type="showPassword ? 'text' : 'password'" outlined @click:append="showPassword = !showPassword" :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"></v-text-field>
						</div>
						<v-card-actions class="px-0">
							<v-btn :loading="form.buttonLoading" type="submit" color="primary" dark block elevation="0" large>Log in</v-btn>
						</v-card-actions>
						<div class="d-flex align-center justify-space-between">
							<v-checkbox v-model="form.data.remember" label="Remember me"></v-checkbox>
						</div>
						<div class="d-flex align-center justify-end">
							<p class="mb-0">
								2021 <span style="color: #0065bd">{{ $config.crr_name }}</span>
							</p>
							. All rights reserved.
						</div>
					</v-container>
				</v-form>
			</v-card>
		</div>
	</div>
</template>

<script>
export default {
	middleware: ['guest'],
	layout: 'simple',
	data() {
		return {
			showPassword: false,
			form: {
				buttonLoading: false,
				data: {
					email: '',
					password: '',
					remember: false,
				},
				rules: {
					email: [(v) => !!v || 'E-mail is a required field.', (v) => /.+@.+/.test(v) || 'Invalid E-mail address'],
					password: [(v) => !!v || 'Password is a required field.'],
				},
			},
		};
	},
	methods: {
		async authenticateUser() {
			if (this.$refs.loginForm.validate()) {
				// api for submit
				this.form.buttonLoading = true;

				await this.$axios
					.post('/login', this.form.data)
					.then(async (res) => {
						this.$store.dispatch('auth/saveToken', {
							token: res.data.token,
							remember: this.form.data.remember,
						});

						await this.$store.dispatch('auth/fetchUser');

						this.$router.push({name: 'home'});
					})
					.catch((err) => {
						if (err.response.status == '403' || err.response.status == '422') {
							this.$toast.open({
								message: 'Error',
								type: 'error',
								duration: 3000,
								pauseOnHover: true,
							});
						} else {
							throw err.response.data;
						}
					})
					.finally(() => {
						this.form.buttonLoading = false;
					});
			}
		},
	},
};
</script>

<style lang="scss" scoped>
.login-card-container {
	position: relative;
	height: 100vh;

	.login-card {
		position: absolute;
		min-width: 700px;
		left: 50%;
		top: 50%;
		-webkit-transform: translate(-50%, -50%);
		transform: translate(-50%, -50%);
	}

	.login-card-title {
		animation: moveUp 1s ease;
	}
}

@keyframes moveUp {
	from {
		opacity: 0;
		transform: translateY(20px);
	}
	to {
		opacity: 1;
		transform: translateY(0);
	}
}
</style>
